//
//  Copyright © 2017 dahua. All rights reserved.
//

#ifndef DHPubDefine_h
#define DHPubDefine_h

// 整型索引
typedef NSInteger Index;

// 长整型索引
typedef int64_t LongIndex;

/// Http类型
typedef NS_ENUM(NSInteger,DHServerPortType)
{
    DHServerPortTypeHttp = 80,       //http 交互方式
    DHServerPortTypeHttps = 443      //https 交互方式
};

//Mark::NVR,增加通道
typedef NS_ENUM(NSInteger, DeviceCatalog)
{
    DeviceCatalogCamera,     //摄像头
    DeviceCatalogBox,        //盒子
    DeviceCatalogBoxPart,    //盒子配件
    DeviceCatalogNVR,        //NVR设备
    DeviceCatalogNVRChannel, //NVR设备通道
    DeviceCatalogG1,         //报警网关
    DeviceCatalogG1Part      //报警网关配件
};

////RTSP对应错误码
//typedef NS_ENUM(NSInteger, RtspStatus)
//{
//    STATE_PACKET_FRAME_ERROR,		//组帧失败
//    STATE_RTSP_TEARDOWN_ERROR,		//内部要求关闭，如连接断开等
//    STATE_RTSP_DESCRIBE_READY,		//会话已经收到Describe 响应
//    STATE_RTSP_AUTHORIZATION_FAIL,	//RTSP鉴权失败
//    STATE_RTSP_PLAY_READY,			//收到 play 响应
//    STATE_RTSP_FILE_PLAY_OVER,		//录像文件回放正常结束
//    STATE_RTSP_PAUSE_READY,          //收到PAUSE响应
//    STATE_RTSP_KEY_MISMATCH,        //密钥不正确
//    STATE_RTSP_P2P2_FAILED = 99 ,    //p2p已经被别人占用，基于503错误码的连接最大数错误
//    STATE_RTSP_USER_INFO_BASE_START, //用户信息起始码，服务端上层传过来的信息码会在该起始码上累加
//    STATE_RTSP_STOPED_INSIDE = 9
//};
//设备录像回调
//typedef NS_ENUM (NSInteger, PlayerResultCode) {
//    STATE_RTSP_PACKET_FRAME_ERROR = 0, // 组帧失败,错误状态
//    STATE_RTSP_TEARDOWN_ERROR,         // 内部要求关闭，如连接断开等，错误状态
//    STATE_RTSP_DESCRIBE_READY,         // 会话已经收到Describe响应，连接建立中
//    STATE_RTSP_AUTHORIZATION_FAIL,     // RTSP鉴权失败，错误状态
//    STATE_RTSP_PLAY_READY,             // 收到PLAY响应，连接成功
//    STATE_RTSP_FILE_PLAY_OVER,         // 录像文件回放正常结束
//    STATE_RTSP_PAUSE_READY,            // 收到PAUSE响应
//    STATE_RTSP_KEY_MISMATCH,           // 密钥错误
//    STATE_RTSP_SERVICE_UNAVAILABLE,    // 基于503错误吗的连接最大数错误，错误状态
//    STATE_RTSP_USER_INFO_BASE_START,     // 用户信息起始码，服务端上层传过来的信息码会在该起始码基础上累加，错误状态
//    STATE_HTTP_PRIVATE_PLAYING = 1001   //正在播放（非SDK状态，App内部使用，当onPlayBegan回调收到时，置为该模式）
//};


typedef NS_ENUM(NSInteger, DHChannelListType)
{
    DHChannelListTypeCoverFlow,
    DHChannelListTypeList,
    DHChannelListTypeRecord
} ;

typedef NS_ENUM(NSInteger, SDCardStatus)
{
    SDCardStatusException  = 0,//  sd卡异常
    SDCardStatusNormal     = 1,//  sd卡正常
    SDCardStatusNoCard     = 2,//  没有sd卡
    SDCardStatusFormatting = 3,//  正在初始化
    SDCardStatusError      = 4 //  不存在
};

//针对公有云消息
typedef NS_ENUM(NSInteger, HlsStatus)
{
    HlsStatusDownloadFail,	 //下载失败
    HlsStatusDownloadBegin,  //开始下载
    HlsStatusDownloadEnd,    //下载结束
    HlsStatusSeekSuccess,    //定位成功
    HlsStatusSeekFail,       //定位失败
    HlsStatusAbortDone,      //
    HlsStatusResumeDone,     //
    HlsStatusKeyError = 11,  //密码不匹配
};

// 加载状态
typedef NS_ENUM(NSInteger, DHLoadingStatus)
{
	DHLoadingStatusUnknown,	 // 未知
	DHLoadingStatusLoading,	 // 加载中
	DHLoadingStatusSuccess,	 // 加载成功
	DHLoadingStatusFail,	 // 加载失败
};

#pragma mark- 公用宏

#define SCREEN_WIDTH        [[UIScreen mainScreen] bounds].size.width
#define SCREEN_HEIGHT       [[UIScreen mainScreen] bounds].size.height

// 屏幕宽度
#define DH_SCREEN_SIZE_WIDTH     MIN([[UIScreen mainScreen]bounds].size.width, [[UIScreen mainScreen]bounds].size.height)
// 屏幕高度
#define DH_SCREEN_SIZE_HEIGHT    MAX([[UIScreen mainScreen]bounds].size.width, [[UIScreen mainScreen]bounds].size.height)

// 状态栏高度
#define DH_StatusBarHeight  ([UIApplication  sharedApplication].statusBarFrame.size.height)

// 导航栏高度
#define DHL_NavigationBarHeight  44.f

// Tabbar高度
#define DH_TabbarHeight    (DH_IS_IPHONEX ? (49.f+34.f) : 49.f)

// 导航栏加状态栏高度
#define DH_StatusBarAndNavigationBarHeight  (44.f + [UIApplication  sharedApplication].statusBarFrame.size.height)

// 安全区域间隔
#define DH_ViewSafeAreInsets(view) ({UIEdgeInsets insets; if(@available(iOS 11.f, *)) {insets = view.safeAreaInsets;} else {insets = UIEdgeInsetsZero;} insets;})

// 底部安全距离
#define DH_BottomSafeMargin (DH_IS_IPHONEX ? 34.f : 0.f)
// 顶部安全距离
#define DH_TopSafeMargin (DH_IS_IPHONEX ? 24.f : 0.f)
// 横屏左右的安全距离
#define DH_LandscapeSafeMargin (DH_IS_IPHONEX ? 44.f : 0.f)
// 横屏左右的视频安全距离
#define DH_LandscapeVideoSafeMargin (DH_IS_IPHONEX ? 64.f : 0.f)
// 导航栏加状态栏高度
#define DH_NavViewHeight (DH_IS_IPHONEX ? 84.f : 64.f)
// 屏幕安全高度
#define DH_ScreenSafeHeight (DH_IS_IPHONEX ? (DH_SCREEN_SIZE_HEIGHT - 58.f) : DH_SCREEN_SIZE_HEIGHT)

#define DH_SIZE_SCALE            (1.f / [UIScreen mainScreen].scale)
// 默认动画时间
#define DH_AnimationDuration 0.4f

#define DH_LEGAL_PASSWORD_REGEX @"^[A-Za-z0-9!#%,<=>@_~`\\-\\.\\/\\(\\)\\*\\+\\?\\$\\[\\]\\\\\\^\\{\\}\\|]$"
// 对象释放打印
#define DH_LOG_DEALLOCED   {NSLog(@" 💔💔💔 %@ dealloced 💔💔💔", NSStringFromClass(self.class));}
// 图片快捷方式
#define DH_IMAGENAMED(imageName)  [UIImage imageNamed:imageName]

// 主窗口
#define DH_KEY_WINDOW ([UIApplication sharedApplication].delegate).window

#define DH_IOS_VERSION ([[[UIDevice currentDevice] systemVersion] floatValue]) //iOS版本号

#define DH_CLIENT_OS_VERSION ([NSString stringWithFormat:@"iOS%@", [[UIDevice currentDevice] systemVersion]]) //iOS系统版本号

#define DH_iOS11_OR_LATER ([[[UIDevice currentDevice] systemVersion] floatValue] >= 11.0)
#define DH_iOS10_OR_LATER ([[[UIDevice currentDevice] systemVersion] floatValue] >= 10.0)


// 判断是否为iPhone 5/5s
#define DH_IS_IPHONE5 (DH_SCREEN_SIZE_WIDTH == 320.0f && DH_SCREEN_SIZE_HEIGHT == 568.0f)

// 判断是否为iPhone 6/6s/7/8
#define DH_IS_IPHONE6_6s (DH_SCREEN_SIZE_WIDTH == 375.0f && DH_SCREEN_SIZE_HEIGHT == 667.0f)

// 判断是否为iPhone X
#define DH_IS_IPHONEX ((DH_SCREEN_SIZE_WIDTH == 375.0f && DH_SCREEN_SIZE_HEIGHT == 812.0f) || ((DH_SCREEN_SIZE_WIDTH == 414 && DH_SCREEN_SIZE_HEIGHT == 896)))

// 判断是否为iPhone 6Plus/6sPlus/7Plus/8Plus
#define DH_IS_IPHONE6Plus_6sPlus (DH_SCREEN_SIZE_WIDTH == 414.0f && DH_SCREEN_SIZE_HEIGHT == 736.0f)

#pragma mark - Convinience RETURN Macro
#define DH_RETURN_IF_TRUE(checkVal) {if(checkVal) \
{NSLog(@"🍎🍎🍎####:%s,Check value true,return...", __FUNCTION__);return;}}   //判断为真返回

#define DH_RETURN_IF_FALSE(checkVal) {if(!(checkVal)) \
{ NSLog(@"🍎🍎🍎####:%s,Check value false,return...", __FUNCTION__); return;}} //判断为假返回

#define DH_RETURN_NIL_IF_TRUE(checkVal) {if(checkVal) \
{NSLog(@" 🍎🍎🍎####:%s,Check value true,return...", __FUNCTION__);return nil;}}   //判断为真返回空值

#define DH_RETURN_NIL_IF_FALSE(checkVal) {if(!(checkVal)) \
{ NSLog(@" 🍎🍎🍎####:%s,Check value false,return...", __FUNCTION__); return nil;}} //判断为假返回空值

#define kAutoHideBarTime    (4.0f)  //悬浮条自动隐藏时间

#define kPictureHideBarTime    (5.0f)  //抓图录制图片自动隐藏时间

#pragma mark - 日期格式
//日期格式
#define kFormatTimeLocal        (@"yyyyMMdd'T'HHmmss")

#define DEVICE_NAME_MAX_LIMIT     32
#define CHANNEL_NAME_MAX_LIMIT    32

#pragma mark - Text

//密码允许的字符(由于3.0.5版本引入安全基线需求，需要兼容旧的密码规则）
#define DH_LEGAL_PASSWORD_OLD   @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890~`!@#$%^&*()-_+={[]}|\\:;'\"<,>.?/ "
#define DH_LEGAL_PASSWORD       @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!#$%()*+,-./<=>?@[\\]^_`{|}~"
#define DH_LEGAL_ACCOUNT        @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890@_-."
#define DH_LEGAL_ACCOUNT_WITHOUT_LIMIT       @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!#$%()*+,-./<=>?@[\\]^_`{|}~&'"
#define DH_LEGAL_NUMBER         @"1234567890"
#define DH_LEGAL_NUMBERnABC     @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"

#define DH_PASSWORD_MIN_LENGTH      8   //密码最小长度
#define DH_PASSWORD_MAX_LENGTH      32  //密码最大长度
#define DH_USERNAME_MAX_LENGTH      11  //登录名最大长度

//PushSound 铃声后缀
#define DH_Sound_FileExtensionName       @"wav"
//默认铃声
#define DH_Sound_Default                 @"sms-received1"
#define DH_Sound_Default_FullName        @"sms-received1.wav"
//呼叫铃声
#define DH_Sound_Calling                 @"sms-lcCalling"
#define DH_Sound_Call                    @"b"
#define DH_Sound_Calling_FullName        @"sms-lcCalling.wav"

//sos报警铃声
#define DH_SOS_Alarm                     @"alarm"

//经典铃声
#define DH_Sound_Classical               @"sms-lcClassical"
#define DH_Sound_Classical_Long          @"sms-lcClassical-long"
#define DH_Sound_Classical_FullName      @"sms-lcClassical.wav"
#define DH_Sound_Classical_Long_FullName @"sms-lcClassical-long.wav"
//报警铃声
#define DH_Sound_Alarm                   @"sms-lcAlarm"
#define DH_Sound_Alarm_Long              @"sms-lcAlarm-long"
#define DH_Sound_Alarm_FullName          @"sms-lcAlarm.wav"
#define DH_Sound_Alarm_Long_FullName     @"sms-lcAlarm-long.wav"
//清晨铃声
#define DH_Sound_Morning                 @"sms-lcMorning"
#define DH_Sound_Morning_Long            @"sms-lcMorning-long"
#define DH_Sound_Morning_FullName        @"sms-lcMorning.wav"
#define DH_Sound_Morning_Long_FullName   @"sms-lcMorning-long.wav"
//设备添加流程语音提示(3.7新增)
#define DH_Sound_AddDevice_Wifi                  @"voiceprompt-lcSetWifi"
#define DH_Sound_AddDevice_Wifi_FullName         @"voiceprompt-lcSetWifi.wav"
#define DH_Sound_AddDevice_PSW                   @"voiceprompt-lcDevicePsw"
#define DH_Sound_AddDevice_PSW_FullName          @"voiceprompt-lcDevicePsw.wav"



//是否需要弹出系统通知
#define LatestSystemPushId               @"LatestSystemPushId"

//指纹登录开关
#define DH_LoginWithTouchID @"loginWithTouchID"
//指纹登录安装引导
#define DH_LoginWithTouchIDGuideHelp @"hasShownTouchLoginGuideHelp"


#define DH_LOG_FUN    NSLog(@"FUNCTION____%s____line%d____",__FUNCTION__,__LINE__);
// 定义单例
#pragma mark Singleton

#define SYNTHESIZE_SINGLETON_FOR_CLASS_HEADER(__CLASSNAME__)    \
\
+ (__CLASSNAME__*) sharedInstance;    \

#define SYNTHESIZE_SINGLETON_FOR_CLASS(__CLASSNAME__) \
\
+ (__CLASSNAME__ *)sharedInstance { \
static __CLASSNAME__ *shared##__CLASSNAME__ = nil; \
static dispatch_once_t onceToken; \
dispatch_once(&onceToken, ^{ \
shared##__CLASSNAME__ = [[self alloc] init]; \
}); \
return shared##__CLASSNAME__; \
}

///MARK: Fix Category Bug
#define TT_FIX_CATEGORY_BUG(name) @interface TT_FIX_CATEGORY_BUG_##name:NSObject @end \
@implementation TT_FIX_CATEGORY_BUG_##name @end

#endif /* DHPubDefine_h */
